import numpy as np
cimport numpy as np  # for np.ndarray

# Numpy must be initialized. When using numpy from C or Cython you must
# _always_ do that, or you will have segfaults
np.import_array()


cdef extern from "numpy/arrayobject.h":
    void PyArray_ENABLEFLAGS(np.ndarray arr, int flags)

cdef extern from "set_integer.h":
    void computeXPCS(float*&, float*&)


#    cdef int x
#    set_integer_ref(x)
#    return x
#
#
#    cdef int[1] x
#    set_integer_ptr(x)
#    return x[0]
#
#
#    cdef np.ndarray[int, ndim=1, mode='c'] x
#
#    x = np.zeros((1,), dtype=np.int32)
#    set_integer_ptr(&x[0])
#    return x[0]
#
#
#    cdef int* x
#    set_integer_ref_ptr(x)
#    return x[0]
#
#
#    cdef int* x
#    set_integer_ptr_ptr(&x)
#    return x[0]
#
#
#    cdef np.ndarray[int, ndim=1, mode='c'] a
#
#    a = np.zeros((4,), dtype=np.int32)
#    set_integer_arr_ptr(&a[0])
#    return a


cpdef doXPCS(np.ndarray[np.float32_t, ndim=3] in_ptr, np.ndarray[np.float32_t, ndim=2] out_ptr):
    #cdef:
    #    float* in_ptr
    #    float* out_ptr
    #    np.npy_intp shape[2]

    computeXPCS(&in_ptr[0,0,0], &out_ptr[0,0])

    # 1. Make sure that you have called np.import_array()
    # http://gael-varoquaux.info/programming/
    # cython-example-of-exposing-c-computed-arrays-in-python-without-data-copies.html
    # 2. OWNDATA flag is important. It tells the NumPy to free data when the python object is deleted.
    # https://stackoverflow.com/questions/23872946/force-numpy-ndarray-to-take-ownership-of-its-memory-in-cython/
    # You can verify that the memory gets freed when Python object is deleted by using tools such as pmap.
    #shape[0] = <np.npy_intp>(2)
    #shape[1] = <np.npy_intp>(2)
    
    #cdef np.ndarray[float, ndim=2] a = np.PyArray_SimpleNewFromData(2, shape, np.NPY_FLOAT, out_ptr)
    #PyArray_ENABLEFLAGS(a, np.NPY_OWNDATA)
    return 1